package de.uhh.informatik.vsis.gss.aufgaben;

import de.uhh.informatik.vsis.gss.tools.Drucker;

/**
 * Klasse zum Testen der Implementierung
 */
public class DruckTest {
	public static final int DRUCKER = 3;
	public static final int THREADS = 5;
	public static final int DOKUMENTE = 9;

	private final Druckdienst dd;
	private final Drucker[] drucker;
	private final Thread[] threads = new Thread[THREADS];

	public DruckTest() {
		// Drucker initialisieren
		drucker = new Drucker[DRUCKER];
		for (int i = 0; i < drucker.length; i++) {
			drucker[i] = new Drucker(i+1);
		}

		// Druckdienst initialisieren
		// TODO Hier an jeweils aktuelle Klasse anpassen
		dd = new DruckdienstNaiv(drucker);
		//dd = new DruckdienstTSL(drucker);
		//dd = new DruckdienstSemaphore(drucker);
		//dd = new DruckdienstMonitor(drucker);

		// Threads initialisieren und starten;
		for(int i=0; i<threads.length; i++) {
			threads[i] = new DruckThread(i+1);
			threads[i].start();
			try {
				Thread.sleep(100);
			} catch (InterruptedException e) {
			}
		}

		// Auf Ende der Threads warten
		for(int i=0; i<threads.length; i++) {
			try {
				threads[i].join();
			} catch (InterruptedException e) {
			}
		}

		// Logs der Drucker anzeigen
		for (int i = 0; i < drucker.length; i++) {
			drucker[i].printLog();
		}
	}

	/**
	 * Druck-Thread, der eine bestimmte Anzahl von Dokumenten an den Druckdienst schickt und sich dann beendet.
	 */
	class DruckThread extends Thread {
		private final int nr;

		public DruckThread(int nr) {
			this.nr = nr;
			setName("Thread "+nr);
		}

		@Override
		public void run() {
			String dok;
			for(int i=0; i<DOKUMENTE; i++) {
				dok = "Dokument "+nr+"."+(i+1);
				System.err.println(Thread.currentThread().getName()+" druckt "+dok);
				dd.drucke(dok);
			}
		}
	}

	public static void main(String argv[]) {
		new DruckTest();
	}
}
