package de.uhh.informatik.vsis.gss.aufgaben;

import de.uhh.informatik.vsis.gss.tools.Drucker;
import de.uhh.informatik.vsis.gss.tools.Tools;

public class DruckdienstNaiv implements Druckdienst {
	private final Drucker[] drucker;
	private final boolean[] istfrei;

	public DruckdienstNaiv(Drucker[] drucker) {
		this.drucker = drucker;
		istfrei = new boolean[drucker.length];
		for (int i = 0; i < istfrei.length; i++) {
			istfrei[i] = true;
		}
	}

	public void drucke(String str) {
		int nr = -1;
		while(nr<0) {
			for(int i=0; i<istfrei.length; i++) {
				if(istfrei[i]) {
					nr = i;
					break;
				}
			}
		}
		Tools.busyWait(250); // Wahrscheinlichkeit erhhen, dass Race Condition tatschlich zu Problemen fhrt
		istfrei[nr] = false;

		drucker[nr].drucke(str);

		istfrei[nr] = true; // Drucker freigeben
	}
}
