package de.uhh.informatik.vsis.gss.sync;

/**
 * Gegenseitiger Ausschluss auf der Basis einer Semaphore mit dem Wert 1
 */
public class Mutex {
	private final Semaphore s;

	/**
	 * Initalisiert den gegenseitigen Ausschluss
	 */
	public Mutex() {
		s = new Semaphore(1);
	}

	/**
	 * Sperrt den Mutex (Eintritt in den kritischen Abschnitt)
	 */
	public void lock() {
		s.P();
	}

	/**
	 * Gibt den Mutex wieder frei (Austritt aus dem kritischen Abschnitt)
	 */
	public void unlock() {
		s.V();
	}
}
